import BergxSDK, { TryResponse } from '@bergx/bergx-sdk';
import { userService } from '../users/userService';
import { DBUser } from '../users/usersMapper';

const bergxService = new BergxSDK({
  clientId: process.env.BX_CLIENT_ID,
  clientSecret: process.env.BX_CLIENT_SECRET,
  updateAccessTokenCallback: (userSub: string, newAccessToken: string) => {
    // finds the user in the database and updates the accessToken
    userService.find(userSub).then((user: DBUser) => {
      user.accessToken = newAccessToken;
      userService.update(user);
    });
  }
});

export default bergxService;
