import * as express from 'express';
import * as passport from 'passport';
import bergxService from '../Bergx/bergxService';

var router = express.Router();

const debug = require('debug')('frame:usersRoutes');

router.get('/profile/me', [
  passport.authenticate('oauth2'),
  (req, res, next) => {
    bergxService.getProfile(req.user).then((info) => {
      res.status(200);
      res.json(info);
    }).catch((err) => {
      res.status(500);
      res.json({
        status: 'error',
        message: err.message
      });
    });
  }
]);

module.exports = router;
