import { Database } from './db/db';
import { Mapper } from './db/Mapper';
import { Altitude, Job } from './db/Altitude';
import jobs from './migrationJobs';

let db = new Database({
  host: process.env.DB_HOST,
  port: process.env.DB_PORT || '3306',
  user: process.env.DB_USER,
  password: process.env.DB_PASSWORD,
  database: process.env.DB_NAME,
});
let mapper = new Mapper(db);
let altitude = new Altitude(mapper);

jobs.map((job) => {
  altitude.addMigration(job);
});

export {
  altitude,
  db,
  mapper
};
