import { Database } from './db';

class Mapper {
  constructor(public database: Database) {}

  public runQuery(query: string, values: any): Promise<any[]> {
    let defer = new Promise<any[]>((resolve, reject) => {
      let connection = this.database.getConnection();
      connection.connect();
      connection.query(query, values, (error, results, fields) => {
        if (error) {
          reject(error);
        } else {
          resolve(results);
        }
      });
      connection.end();
    });
    return defer;
  }
}

export {
  Mapper
};
