import { Job } from '../db/Altitude';
import * as fs from 'fs';
import * as path from 'path';

let jobs: Job[] = [];

let files = fs.readdirSync(path.join(__dirname)).filter(file => file !== 'index.js');
for (let i in files) {
  try {
    var data = fs.readFileSync(path.join(__dirname, files[i]), 'utf8');
    let parts = data.split('--down').filter(part => part.indexOf('--up') !== -1);
    if (parts.length) {
      // there is an up command in this file
      let upParts = parts[0].split('--up');
      jobs.push({
        creator: 'system',
        name: files[i],
        query: upParts[1].split('\n').join('')
      });
    }
  } catch(e) {
      console.log('Error:', e.stack);
  }
}

console.log(jobs);

// SYSTEM-BUILDER-jobs.push

export default jobs;
