import {ComponentDef, EndpointDef, SystemDef} from "../systemGenService";
import path from "path";
import fs from "fs";

export function buildAppLinks(component: ComponentDef, outDir: string, systemDef: SystemDef): Promise<void> {
    let listEndpoints: EndpointDef[] = component.endpoints.filter((epd: EndpointDef) => {
        return epd.type === 'list';
    });
    if (listEndpoints.length) {
        return new Promise<void>((resolve) => {
            const separator: string = `<!-- SYSTEM-BUILDER-list-components-html -->`;
            let fileLocation = path.join(process.cwd(), `frontend-${systemDef.name}`, 'src', 'App.vue');
            let initServiceFile: string = fs.readFileSync(fileLocation, 'utf8');
            let parts = initServiceFile.split(separator);
            parts[0] = parts[0] + createLinksMarkup(component, systemDef);
            let newServiceFile = parts.join(separator);
            fs.writeFileSync(fileLocation, newServiceFile, 'utf8');
            resolve();
        });
    }
    return Promise.resolve();
}

function createLinksMarkup(component: ComponentDef, systemDef: SystemDef): string {
    let out = `<router-link to="/${component.component}">${component.component} List</router-link><br/>
  `;

    return out;
}