import {ComponentDef, EndpointDef, SystemDef} from "../systemGenService";
import path from "path";
import fs from "fs";
import {createDetailsTypeValues} from "../helpers";

export function buildTypesView(component: ComponentDef, outDir: string, systemDef: SystemDef): Promise<void> {
    if (component.endpoints.length) {
        return insertFEDetailsCode(component.endpoints[0], outDir, systemDef);
    } else {
        return Promise.resolve();
    }
}

function insertFEDetailsCode(view: EndpointDef, outDir: string, systemDef: SystemDef) {
    return new Promise<void>((resolve) => {
        const separator: string = `// SYSTEM-BUILDER-init-props`;
        let fileLocation = path.join(outDir, `${view.component}Types.ts`)
        let initServiceFile: string = fs.readFileSync(fileLocation, 'utf8');
        let parts = initServiceFile.split(separator);
        parts[0] = parts[0] + createDetailsTypeValues(view, systemDef);
        let newServiceFile = parts.join(separator);
        fs.writeFileSync(fileLocation, newServiceFile, 'utf8');
        resolve();
    });
}