import { SystemDef } from './processDef';

var simmer: SystemDef = {
  storage: {
    tables: [
      {
        name: 'cooks',
        relations: [],
        columns: [
          {
            name: 'name',
            type: 'string',
            nullable: false
          },
          {
            name: 'location',
            type: 'string',
            nullable: false
          },
        ]
      },
      {
        name: 'customers',
        relations: [],
        columns: [
          {
            name: 'name',
            type: 'string',
            nullable: false
          },
          {
            name: 'location',
            type: 'string',
            nullable: false
          },
          {
            name: 'cardInfo',
            type: 'string',
            nullable: true
          },
        ]
      },
      {
        name: 'dishes',
        relations: [
          {
            type: 'belongs-to',
            table: 'cooks',
          }
        ],
        columns: [
          {
            name: 'name',
            type: 'string',
            nullable: false
          },
          {
            name: 'picture',
            type: 'string',
            nullable: false
          },
          {
            name: 'prices',
            type: 'string',
            nullable: true
          },
        ]
      },
      {
        name: 'ratings',
        relations: [
          {
            type: 'belongs-to',
            table: 'customers',
          },
          {
            type: 'belongs-to',
            table: 'cooks',
          }
        ],
        columns: [
          {
            name: 'amount',
            type: 'number',
            nullable: false
          },
        ]
      },
    ],
    relations: []
  },
  views: []
};

export default simmer;
